{ MP3    .
  ()  .., 2003. }
unit mp3p_;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, MPlayer, ComCtrls,

  MMSYSTEM, FileCtrl; //    

type
  TForm1 = class(TForm)
    // 
    SpeedButton1: TSpeedButton; //  
    SpeedButton2: TSpeedButton; // /
    SpeedButton3: TSpeedButton; //  
    SpeedButton4: TSpeedButton; //  

    ListBox1: TListBox; //   (mp3 )

    MediaPlayer1: TMediaPlayer; //  

    TrackBar1: TTrackBar; //  

    Timer1: TTimer;
    Label1: TLabel;
    Label2: TLabel;

    Shape1: TShape; //   

    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);

    //     
    procedure Play; // 
    procedure PlayList(Path: string); //   MP3 

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
var
  SoundPath: string[255];
  min,sec: integer; //  
  volume: LongWord; //   -  ,
                    //  - .

//   MP3 
procedure TForm1.PlayList(Path: string);
var
  lpBuf: PChar;          //   nul-terminated 
  sWinDir: string[128];  //   

  SearchRec: TSearchRec; //  SearchRec  
                         //  ,   
begin
  ListBox1.Clear;
  //   mp3 
  if FindFirst(Path + '*.mp3', faAnyFile, SearchRec) =0 then
     begin
          //       WAV
          //      
          ListBox1.Items.Add(SearchRec.Name);
          //         WAV
          while (FindNext(SearchRec) = 0) do
              ListBox1.Items.Add(SearchRec.Name);
     end;
   ListBox1.ItemIndex := 0;  
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   PlayList('');
   ListBox1.ItemIndex := 0;
   Label1.Caption:=ListBox1.Items[ListBox1.itemIndex];

   TrackBar1.Position := 7;

   //    volume -  ,
   //  - 
   volume := (TrackBar1.Position - TrackBar1.Max+1)* 6500;
   volume := volume +   (volume shl 16);
   waveOutSetVolume(WAVE_MAPPER,volume); //  
end;

//    
procedure TForm1.ListBox1Click(Sender: TObject);
begin
  //     Label1   
 if not SpeedButton2.Down
    then  SpeedButton2.Down := True;
 Label1.Caption:=ListBox1.Items[ListBox1.itemIndex];
 Play;
end;

//    
procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  if SpeedButton2.Down then
    //   
    //  
    Play
  else
    //    ,
    //    
    // 
    begin
      MediaPlayer1.Stop;
      Timer1.Enabled := False;
      SpeedButton2.Down := False;
      SPeedButton2.Hint := 'Play';
    end;
end;

//   
procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex > 0 then
        ListBox1.ItemIndex := ListBox1.ItemIndex - 1;
  Play;
end;

//   
procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  if ListBox1.ItemIndex < ListBox1.Count then
        ListBox1.ItemIndex := ListBox1.ItemIndex + 1;
  Play;
end;

//   
//  
procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  volume := 6500* (TrackBar1.Max - TrackBar1.Position);
  volume := volume +   (volume shl 16);
  waveOutSetVolume(WAVE_MAPPER,volume);
end;


//  ,
//   
//   ListBox1
procedure TForm1.Play;
begin
  Timer1.Enabled := False;
  Label1.Caption:=ListBox1.Items[ListBox1.itemIndex];
  MediaPlayer1.FileName := SoundPath + ListBox1.Items[ListBox1.itemIndex];

  try
   Mediaplayer1.Open;
  except
    on EMCIDeviceError do
      begin
        ShowMessage('    '+
                     ListBox1.Items[ListBox1.itemIndex]);
        SpeedButton2.Down := False;
        exit;
      end;
  end;
  MediaPlayer1.Play;
  min :=0;
  sec :=0;
  Timer1.Enabled := True;
  SpeedButton2.Hint := 'Stop';
end;

//   
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  //   
  if sec < 59
    then inc(sec)
    else begin
      sec :=0;
      inc(min);
    end;

  //   
  Label2.Caption := IntToStr(min)+':';
  if sec < 10
    then Label2.Caption :=
           Label2.Caption +'0'+ IntToStr(sec)
    else Label2.Caption :=
           Label2.Caption + IntToStr(sec);

  //    
  //  
  if MediaPlayer1.Position < MediaPlayer1.Length
    then exit;

  //   
  // 
  Timer1.Enabled := False; //  
  MediaPlayer1.Stop;       //  

  if ListBox1.ItemIndex < ListBox1.Count //   
  then begin
        ListBox1.ItemIndex := ListBox1.ItemIndex + 1;
        Play;
       end
end;

//    
//  ,    MP3 
procedure TForm1.SpeedButton4Click(Sender: TObject);
var
  Root: string;      //  
  pwRoot : PWideChar;
  Dir: string;
begin
  Root := ''; //   -   
  GetMem(pwRoot, (Length(Root)+1) * 2);
  pwRoot := StringToWideChar(Root,pwRoot,MAX_PATH*2);
  if not SelectDirectory(' ', pwRoot, Dir)
     then Dir :=''
     else Dir := Dir+'\';

  // ,    MP3  
  SoundPath := Dir;
  PlayList(SoundPath);
end;

end.
